import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.Vector;

public class DonkeyGui extends JFrame
{

	DonkeyGui(final DonkeyCore donkeyCore)
	{
		Dimension screensize=Toolkit.getDefaultToolkit().getScreenSize();
		
		// Splash window
		JWindow splash=new JWindow();
		splash.getContentPane().add(new JLabel(new ImageIcon(getClass().getResource("/splash.jpg"))));
		splash.pack();
		Dimension windowsize=splash.getSize();
    splash.setLocation((screensize.width-windowsize.width)/2,(screensize.height-windowsize.height)/2);
	  splash.setVisible(true);
		
		// Main window
		setTitle("jMoule");
		setSize(600,400);
    windowsize=getSize();
    setLocation((screensize.width-windowsize.width)/2,(screensize.height-windowsize.height)/2);
		addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e)
      {
        System.exit(0);
      }
    });
    
    JTabbedPane tabbedPane=new JTabbedPane();
		getContentPane().add(tabbedPane);

		// Control panel
		JPanel controlPanel=new JPanel();
		JPanel connectPanel=new JPanel();
		connectPanel.add(new JLabel("Host : "));
		final JTextField hostText=new JTextField("",10);
    connectPanel.add(hostText);
		connectPanel.add(new JLabel("Password : "));
		final JPasswordField passwordText=new JPasswordField("",5);
    connectPanel.add(passwordText);
    JButton connectButton=new JButton("Connect");
		connectPanel.add(connectButton);
    JButton killButton=new JButton("Kill");
		connectPanel.add(killButton);
    connectButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent event)
      {
		    //System.out.println("connectButton");
		    if (hostText.getText().length()==0) return;
		    donkeyCore.connect(hostText.getText(),4001,new String(passwordText.getPassword()));
      }
    });
    killButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent event)
      {
		    //System.out.println("killButton");
		    donkeyCore.kill();
      }
    });
		tabbedPane.add(connectPanel,"Control");

		// Server panel
		JPanel serverPanel=new JPanel(new BorderLayout());
		JPanel servertopPanel=new JPanel();
		JButton connectMoreButton=new JButton("Connect More");
		servertopPanel.add(connectMoreButton);
		JButton cleanOldButton=new JButton("Clean Old Servers");
		servertopPanel.add(cleanOldButton);
		/*
		JButton sconnectButton=new JButton("Connect");
 		servertopPanel.add(sconnectButton);
		JButton disconnectButton=new JButton("Disconnect");
 		servertopPanel.add(disconnectButton);
 		*/
		serverPanel.add(servertopPanel,"North");
 		//final JTable serverTable=new JTable(new ServerTableModel(donkeyCore.serverInfos));

        TableModel dataModel=new ServerTableModel(donkeyCore.serverInfos,donkeyCore);
        TableSorter sorter=new TableSorter(dataModel);
        JTable tableView=new JTable(sorter);
        tableView.setColumnSelectionAllowed(false);
        tableView.setRowSelectionAllowed(false);
        sorter.addMouseListenerToHeaderInTable(tableView);

 		//serverPanel.add(new JScrollPane(serverTable),"Center");
		serverPanel.add(new JScrollPane(tableView),"Center");
		tabbedPane.add(serverPanel,"Servers");
    connectMoreButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent event)
      {
		    //System.out.println("connectMoreButton");
		    donkeyCore.connectMore();
      }
    });
    cleanOldButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent event)
      {
		    //System.out.println("cleanOldButton");
		    donkeyCore.cleanOld();
      }
    });
		/*
    sconnectButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent event)
      {
		    System.out.println("sconnectButton");
		    for (int i=0;i<serverTable.getSelectedRowCount();i++)
		    {
		    	ServerTableModel m=(ServerTableModel)serverTable.getModel();
		     	//Vector v=(Vector)r.serverInfos.get(serverTable.getSelectedRows()[i]);
			    donkeyCore.connectServer((Long)m.getValueAt(i,0));
		    }
      }
    });
    disconnectButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent event)
      {
		    System.out.println("disconnectButton");
		    for (int i=0;i<serverTable.getSelectedRowCount();i++)
		    {
		    	ServerTableModel m=(ServerTableModel)serverTable.getModel();
		     	//Vector v=(Vector)r.serverInfos.get(serverTable.getSelectedRows()[i]);
			    donkeyCore.disconnectServer((Long)m.getValueAt(i,0));
		    }
      }
    });
    */

		// Search panel
		JPanel searchPanel=new JPanel(new BorderLayout());
    JPanel topPanel=new JPanel();
    topPanel.add(new JLabel("Query : "));
    final JTextField searchText=new JTextField("",15);
    topPanel.add(searchText);
    JButton searchButton=new JButton("Search");
    topPanel.add(searchButton);
    JButton extendButton=new JButton("Extend");
    topPanel.add(extendButton);
    /*
    JButton downloadButton=new JButton("Download");
    topPanel.add(downloadButton);
    */
    searchPanel.add(topPanel,"North");
		final JTabbedPane resultsPane=new JTabbedPane();	
		searchPanel.add(resultsPane,"Center");
		final Vector resultTables=new Vector();
    searchButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent event)
      {
		    //System.out.println("searchButton");
		    if (searchText.getText().length()==0) return;
        Vector searchResult=donkeyCore.search(searchText.getText());
        
        /*
        JTable resultTable=new JTable(new ResultTableModel(searchResult));
        resultTables.add(resultTable);
        resultsPane.add(new JScrollPane(resultTable),searchText.getText());
        resultsPane.setSelectedIndex(resultsPane.getTabCount()-1);
        */
        
        ResultTableModel resultModel=new ResultTableModel(searchResult,donkeyCore);
        TableSorter sorter=new TableSorter(resultModel);
        JTable tableView=new JTable(sorter);
        tableView.setColumnSelectionAllowed(false);
        tableView.setRowSelectionAllowed(false);
        resultTables.add(tableView);
        sorter.addMouseListenerToHeaderInTable(tableView);
        resultsPane.add(new JScrollPane(tableView),searchText.getText());
        resultsPane.setSelectedIndex(resultsPane.getTabCount()-1);

      }
    });
    extendButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent event)
      {
		    //System.out.println("extendButton");
		    donkeyCore.extend();
      }
    });
    /*
    downloadButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent event)
      {
		    System.out.println("downloadButton");
		    JTable resultTable=(JTable)resultTables.get(resultsPane.getSelectedIndex());
		    for (int i=0;i<resultTable.getSelectedRowCount();i++)
		    {
		    	ResultTableModel r=(ResultTableModel)resultTable.getModel();
		     	Vector v=(Vector)r.searchResult.get(resultTable.getSelectedRows()[i]);
		    	donkeyCore.download((Long)v.get(0));
		    }
      }
    });
    */
		tabbedPane.add(searchPanel,"Search");

		// Downloads panel
    //tabbedPane.add(new JScrollPane(new JTable(new DownloadTableModel(donkeyCore.fileInfos))),"Downloads");
        //DownloadTableModel 
        dataModel=new DownloadTableModel(donkeyCore.fileInfos,donkeyCore);
        //TableSorter 
        sorter=new TableSorter(dataModel);
        //JTable 
        tableView=new JTable(sorter);
        tableView.setColumnSelectionAllowed(false);
        tableView.setRowSelectionAllowed(false);
        sorter.addMouseListenerToHeaderInTable(tableView);
        tabbedPane.add(new JScrollPane(tableView),"Downloads");

    // Console panel
    tabbedPane.add(new JScrollPane(donkeyCore.console),"Console");

		try
		{
			Thread.sleep(2000);
		}
		catch (Exception e)
		{}
		splash.setVisible(false);
		show();
		
	}
	
}
