import java.util.Hashtable;
import java.util.Vector;
import javax.swing.table.*;

public class DownloadTableModel extends RefreshAbstractTableModel
{

	Hashtable fileInfos;
	String columns[]={"Number","File Name","Size","Downloaded","%","Rate","Running"};
	DonkeyCore donkeyCore;
	
	public DownloadTableModel(Hashtable fileInfos,DonkeyCore donkeyCore)
	{
		this.donkeyCore=donkeyCore;
		this.fileInfos=fileInfos;
	}
	
	public int getColumnCount()
	{
		return columns.length;
	}
	
	public String getColumnName(int col)
	{
		return columns[col];
	}

	public int getRowCount()
	{
		return fileInfos.size();
	}
	
	public Object getValueAt(int row,int col)
	{
		if (col==0) return fileInfos.keySet().toArray()[row];
		return ((Vector)fileInfos.values().toArray()[row]).get(col-1);
	}

	public boolean isCellEditable(int row,int col)
	{
		return col==columns.length-1;
	}
	
	public void setValueAt(Object o,int row,int col)
	{
		Long id=(Long)getValueAt(row,0);
		Vector fileInfo=(Vector)fileInfos.get(id);
		donkeyCore.switchDownload((Long)getValueAt(row,0),((Boolean)o).booleanValue());
	}

}